VTK: vtkMemoryResourceStream Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
vtkMemoryResourceStream Class Reference

`vtkResourceStream` implementation for memory input. More...

`#include <vtkMemoryResourceStream.h>`

Inheritance diagram for vtkMemoryResourceStream:
[legend]
Collaboration diagram for vtkMemoryResourceStream:
[legend]

## Public Types
typedef vtkResourceStream | Superclass
Public Types inherited from vtkResourceStream
enum class | SeekDirection { Begin = 0 , Current = 1 , End = 2 }
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkMemoryResourceStream * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | SetBuffer (const void *buffer, std::size_t size, bool copy=false)
| Set buffer to stream. More...
template<typename T >
void | SetBuffer (vtkSmartPointer< vtkBuffer< T >> buffer)
| Set buffer to stream. More...
template<typename T , typename Allocator >
void | SetBuffer (std::vector< T, Allocator > vec)
| Set buffer to stream. More...
template<typename CharT , typename Traits , typename Allocator >
void | SetBuffer (std::basic_string< CharT, Traits, Allocator > str)
| Set buffer to stream. More...
bool | OwnsBuffer () const
| Check if `this` has a internally managed buffer. More...
std::size_t | Read (void *buffer, std::size_t bytes) override
| Override vtkResourceStream functions. More...
bool | EndOfStream () override
| Override vtkResourceStream functions. More...
vtkTypeInt64 | Seek (vtkTypeInt64 pos, SeekDirection dir) override
| Override vtkResourceStream functions. More...
vtkTypeInt64 | Tell () override
| Override vtkResourceStream functions. More...
Public Member Functions inherited from vtkResourceStream
vtkResourceStream * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
bool | SupportSeek () const
| Check if stream supports Seek and Tell functions. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkMemoryResourceStream * | SafeDownCast (vtkObjectBase *o)
static vtkMemoryResourceStream * | New ()
Static Public Member Functions inherited from vtkResourceStream
static vtkTypeBool | IsTypeOf (const char *type)
static vtkResourceStream * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkMemoryResourceStream ()
| ~vtkMemoryResourceStream () override=default
| vtkMemoryResourceStream (const vtkMemoryResourceStream &)=delete
vtkMemoryResourceStream & | operator= (const vtkMemoryResourceStream &)=delete
Protected Member Functions inherited from vtkResourceStream
| vtkResourceStream (bool supportSeek)
| Constructor. More...
| ~vtkResourceStream () override
| vtkResourceStream (const vtkResourceStream &)=delete
vtkResourceStream & | operator= (const vtkResourceStream &)=delete
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

`vtkResourceStream` implementation for memory input.

`vtkMemoryResourceStream` can be a view on existing data. Or it can copy specified data into an internal buffer. Or it can take ownership of a `vtkBuffer`, a `std::vector` or a `std::string`.

Definition at line 24 of file vtkMemoryResourceStream.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkResourceStream vtkMemoryResourceStream::Superclass

Definition at line 71 of file vtkMemoryResourceStream.h.

## Constructor & Destructor Documentation

## ◆ vtkMemoryResourceStream() [1/2]

vtkMemoryResourceStream::vtkMemoryResourceStream | ( |  | ) |
| protected

## ◆ ~vtkMemoryResourceStream()

vtkMemoryResourceStream::~vtkMemoryResourceStream | ( |  | ) |
| overrideprotecteddefault

## ◆ vtkMemoryResourceStream() [2/2]

vtkMemoryResourceStream::vtkMemoryResourceStream | ( | const vtkMemoryResourceStream & |  | ) |
| protecteddelete

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkMemoryResourceStream::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkMemoryResourceStream::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkResourceStream.

## ◆ SafeDownCast()

static vtkMemoryResourceStream* vtkMemoryResourceStream::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkMemoryResourceStream::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkResourceStream.

## ◆ NewInstance()

vtkMemoryResourceStream* vtkMemoryResourceStream::NewInstance | ( |  | ) | const

## ◆ New()

static vtkMemoryResourceStream* vtkMemoryResourceStream::New | ( |  | ) |
| static

## ◆ PrintSelf()

void vtkMemoryResourceStream::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ Read()

std::size_t vtkMemoryResourceStream::Read | ( | void * | buffer,
|  | std::size_t | bytes
| ) |  |
| overridevirtual

Override vtkResourceStream functions.

Implements vtkResourceStream.

## ◆ EndOfStream()

bool vtkMemoryResourceStream::EndOfStream | ( |  | ) |
| overridevirtual

Override vtkResourceStream functions.

Implements vtkResourceStream.

## ◆ Seek()

vtkTypeInt64 vtkMemoryResourceStream::Seek | ( | vtkTypeInt64 | pos,
|  | SeekDirection | dir
| ) |  |
| overridevirtual

Override vtkResourceStream functions.

Reimplemented from vtkResourceStream.

## ◆ Tell()

vtkTypeInt64 vtkMemoryResourceStream::Tell | ( |  | ) |
| overridevirtual

Override vtkResourceStream functions.

Reimplemented from vtkResourceStream.

## ◆ SetBuffer() [1/4]

void vtkMemoryResourceStream::SetBuffer | ( | const void * | buffer,
|  | std::size_t | size,
|  | bool | copy = `false`
| ) |  |

Set buffer to stream.

If `copy` is `false`, the source buffer must stay valid as it may be used.

Otherwise, if `copy` is `true`, given buffer will be copied into an internally managed buffer. If `size` is 0, this call won't allocate anything. If `size > 0`, `buffer` must not be `nullptr` and must point to a contiguous buffer of at least `size` bytes.

Regarless of `copy` value, this function also has the following effects:

- Reset stream position to `0`.
- EndOfStream will return `true` if `size` is `0`, `false` otherwise.
- Release currently owned buffer, if any.
- Increase modified time.

Parameters

  buffer | the buffer address, may be nullptr if `size` is 0.
  size | the buffer size in bytes, may be 0.
  copy | if `true` this function copies given buffer to an internally managed buffer.

## ◆ SetBuffer() [2/4]

template<typename T >

void vtkMemoryResourceStream::SetBuffer | ( | vtkSmartPointer< vtkBuffer< T >> | buffer | ) |
| inline

Set buffer to stream.

`this` will keep an owning reference to `buffer` (`buffer` reference count will be increased). While `buffer` is streamed, it must not be invalidated (e.g. calling `vtkBuffer::Allocate`) nor freed. Also note that `buffer` content is still managed by the `vtkBuffer` instance, so it can be modified externally.

Streamed buffer is set as if by calling: `SetBuffer(buffer->GetBuffer(), buffer->GetSize() * sizeof(T), false)`. If `buffer` is nullptr, this function has the same effect as `SetBuffer(nullptr, 0)`. When `buffer` is released, it only decrements the reference count.

Parameters

  buffer | `vtkBuffer` to stream, may be nullptr. `buffer` may also empty.

Definition at line 123 of file vtkMemoryResourceStream.h.

## ◆ SetBuffer() [3/4]

template<typename T , typename Allocator >

void vtkMemoryResourceStream::SetBuffer | ( | std::vector< T, Allocator > | vec | ) |
| inline

Set buffer to stream.

`this` will manage `vec` lifetime internally.

Streamed buffer is set as if by calling: `SetBuffer(vec.data(), vec.size() * sizeof(T), false)`.

Note that this function takes `vec` by value:

- Call `SetBuffer(std::move(vec))` if you no longer need `vec` after the call. This is the most efficient way, because it will not copy `vec` data at all, it will only transfer ownership of `vec` to the stream.
- Call `SetBuffer(vec)` to copy vec. Useful if you need to keep `vec` on caller side.

Parameters

  vec | std::vector to stream, may be empty.

Definition at line 153 of file vtkMemoryResourceStream.h.

## ◆ SetBuffer() [4/4]

template<typename CharT , typename Traits , typename Allocator >

void vtkMemoryResourceStream::SetBuffer | ( | std::basic_string< CharT, Traits, Allocator > | str | ) |
| inline

Set buffer to stream.

Same as `SetBuffer(std::vector<T, Allocator> vec)` but for `std::basic_string`.

Parameters

  str | std::string to stream, may be empty.

Definition at line 167 of file vtkMemoryResourceStream.h.

## ◆ OwnsBuffer()

bool vtkMemoryResourceStream::OwnsBuffer | ( |  | ) | const
| inline

Check if `this` has a internally managed buffer.

This is `true` after a call to `SetBuffer(vtkSmartPointer<vtkBuffer<T>>)` even if only the reference count is managed by the stream.

Returns
  `true` if `this` manage streamed buffer, `false` otherwise.

Definition at line 185 of file vtkMemoryResourceStream.h.

## ◆ operator=()

vtkMemoryResourceStream& vtkMemoryResourceStream::operator= | ( | const vtkMemoryResourceStream & |  | ) |
| protecteddelete

The documentation for this class was generated from the following file:

- IO/Core/vtkMemoryResourceStream.h